diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedEquivalenceRelabeler.hxx b/Modules/Segmentation/Watersheds/include/itkWatershedEquivalenceRelabeler.hxx
index 790e0aa099..8408aec721 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedEquivalenceRelabeler.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedEquivalenceRelabeler.hxx
@@ -23,97 +23,99 @@ namespace itk
 {
 namespace watershed
 {
-template< typename TScalar, unsigned int TImageDimension >
-void EquivalenceRelabeler< TScalar, TImageDimension >
-::GenerateData()
+template <typename TScalar, unsigned int TImageDimension>
+void
+EquivalenceRelabeler<TScalar, TImageDimension>::GenerateData()
 {
-  typename ImageType::ConstPointer input  = this->GetInputImage();
-  typename ImageType::Pointer output = this->GetOutputImage();
+  typename ImageType::ConstPointer input = this->GetInputImage();
+  typename ImageType::Pointer      output = this->GetOutputImage();
 
   typename EquivalencyTableType::Pointer eqT = this->GetEquivalencyTable();
 
-  output->SetBufferedRegion( output->GetRequestedRegion() );
+  output->SetBufferedRegion(output->GetRequestedRegion());
   output->Allocate();
 
   //
   // Copy input to output
   //
-  ImageRegionConstIterator< ImageType > it_a( input, output->GetRequestedRegion() );
-  ImageRegionIterator< ImageType >      it_b( output, output->GetRequestedRegion() );
+  ImageRegionConstIterator<ImageType> it_a(input, output->GetRequestedRegion());
+  ImageRegionIterator<ImageType>      it_b(output, output->GetRequestedRegion());
 
   it_a.GoToBegin();
   it_b.GoToBegin();
-  while ( !it_a.IsAtEnd() )
-    {
-    it_b.Set( it_a.Get() );
+  while (!it_a.IsAtEnd())
+  {
+    it_b.Set(it_a.Get());
     ++it_a;
     ++it_b;
-    }
+  }
 
   eqT->Flatten();
   SegmenterType::RelabelImage(output, output->GetRequestedRegion(), eqT);
 }
 
-template< typename TScalar, unsigned int VImageDimension >
-void EquivalenceRelabeler< TScalar, VImageDimension >
-::GenerateInputRequestedRegion()
+template <typename TScalar, unsigned int VImageDimension>
+void
+EquivalenceRelabeler<TScalar, VImageDimension>::GenerateInputRequestedRegion()
 {
   // call the superclass' implementation of this method
   Superclass::GenerateInputRequestedRegion();
 
   // get pointers to the input and output
-  ImageType *inputPtr  = const_cast< ImageType * >( this->GetInputImage() );
-  ImageType *outputPtr  = this->GetOutputImage();
+  auto *      inputPtr = const_cast<ImageType *>(this->GetInputImage());
+  ImageType * outputPtr = this->GetOutputImage();
 
-  if ( !inputPtr || !outputPtr )
-    {
+  if (!inputPtr || !outputPtr)
+  {
     return;
-    }
+  }
 
   //
   // FOR NOW WE'LL JUST SET THE INPUT REGION TO THE OUTPUT REGION
   // FOR STREAMING WITHIN THE PIPELINE NEED TO FIX THIS
   //
-  inputPtr->SetRequestedRegion( outputPtr->GetRequestedRegion() );
+  inputPtr->SetRequestedRegion(outputPtr->GetRequestedRegion());
 }
 
-template< typename TScalar, unsigned int TImageDimension >
-void EquivalenceRelabeler< TScalar, TImageDimension >
-::GenerateOutputRequestedRegion(DataObject *output)
+template <typename TScalar, unsigned int TImageDimension>
+void
+EquivalenceRelabeler<TScalar, TImageDimension>::GenerateOutputRequestedRegion(DataObject * output)
 {
   // Only the Image output need to be propagated through.
   // No choice but to use RTTI here.
   // All Image outputs set to the same RequestedRegion  other
   // outputs ignored.
-  ImageBase< ImageDimension > *imgData;
-  ImageBase< ImageDimension > *op;
-  imgData = dynamic_cast< ImageBase< ImageDimension > * >( output );
+  ImageBase<ImageDimension> * imgData;
+  ImageBase<ImageDimension> * op;
+  imgData = dynamic_cast<ImageBase<ImageDimension> *>(output);
 
-  if ( imgData )
+  if (imgData)
+  {
+    std::vector<ProcessObject::DataObjectPointer>::size_type idx;
+    for (idx = 0; idx < this->GetNumberOfIndexedOutputs(); ++idx)
     {
-    std::vector< ProcessObject::DataObjectPointer >::size_type idx;
-    for ( idx = 0; idx < this->GetNumberOfIndexedOutputs(); ++idx )
+      if (this->GetOutput(idx) && this->GetOutput(idx) != output)
       {
-      if ( this->GetOutput(idx) && this->GetOutput(idx) != output )
+        op = dynamic_cast<ImageBase<ImageDimension> *>(this->GetOutput(idx));
+        if (op)
         {
-        op = dynamic_cast< ImageBase< ImageDimension > * >( this->GetOutput(idx) );
-        if ( op ) { this->GetOutput(idx)->SetRequestedRegion(output); }
+          this->GetOutput(idx)->SetRequestedRegion(output);
         }
       }
     }
+  }
 }
 
-template< typename TScalar, unsigned int TImageDimension >
-void EquivalenceRelabeler< TScalar, TImageDimension >
-::PrintSelf(std::ostream & os, Indent indent) const
+template <typename TScalar, unsigned int TImageDimension>
+void
+EquivalenceRelabeler<TScalar, TImageDimension>::PrintSelf(std::ostream & os, Indent indent) const
 {
   Superclass::PrintSelf(os, indent);
 }
 
-template< typename TScalar, unsigned int TImageDimension >
-typename EquivalenceRelabeler< TScalar, TImageDimension >::DataObjectPointer
-EquivalenceRelabeler< TScalar, TImageDimension >
-::MakeOutput(DataObjectPointerArraySizeType)
+template <typename TScalar, unsigned int TImageDimension>
+typename EquivalenceRelabeler<TScalar, TImageDimension>::DataObjectPointer
+  EquivalenceRelabeler<TScalar, TImageDimension>::MakeOutput(DataObjectPointerArraySizeType)
 {
   return ImageType::New().GetPointer();
 }
diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.h b/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.h
index be18801514..b0457c3d78 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.h
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.h
@@ -138,46 +138,45 @@ namespace itk
  * Threshold and Level parameters are controlled through the class'
  * Get/SetThreshold() and Get/SetLevel() methods.
  *
- * \par Notes on streaming the watershed segmentation code
- *  Coming soon... 12/06/01
- *
- *
- *
  * \ingroup WatershedSegmentation
  * \ingroup ITKWatersheds
+ *
+ * \sphinx
+ * \sphinxexample{Segmentation/Watersheds/SegmentWithWatershedImageFilter,Watershed Image Filter}
+ * \endsphinx
  */
-template< typename TInputImage >
-class ITK_TEMPLATE_EXPORT WatershedImageFilter:
-  public ImageToImageFilter< TInputImage, Image< IdentifierType,
-                                                 TInputImage::ImageDimension > >
+template <typename TInputImage>
+class ITK_TEMPLATE_EXPORT WatershedImageFilter
+  : public ImageToImageFilter<TInputImage, Image<IdentifierType, TInputImage::ImageDimension>>
 {
 public:
-  /** Standard "Self" typedef.   */
-  typedef WatershedImageFilter Self;
+  ITK_DISALLOW_COPY_AND_ASSIGN(WatershedImageFilter);
+
+  /** Standard "Self" type alias.   */
+  using Self = WatershedImageFilter;
 
   /** The type of input image.   */
-  typedef TInputImage InputImageType;
+  using InputImageType = TInputImage;
 
   /** Dimension of the input and output images. */
-  itkStaticConstMacro (ImageDimension, unsigned int,
-                       TInputImage::ImageDimension);
+  static constexpr unsigned int ImageDimension = TInputImage::ImageDimension;
 
   /** The type of output image.   */
-  typedef Image< IdentifierType, itkGetStaticConstMacro(ImageDimension) > OutputImageType;
+  using OutputImageType = Image<IdentifierType, Self::ImageDimension>;
 
-  /** Other convenient typedefs   */
-  typedef typename InputImageType::RegionType RegionType;
-  typedef typename InputImageType::SizeType   SizeType;
-  typedef typename InputImageType::IndexType  IndexType;
+  /** Other convenient type alias   */
+  using RegionType = typename InputImageType::RegionType;
+  using SizeType = typename InputImageType::SizeType;
+  using IndexType = typename InputImageType::IndexType;
 
-  /** Standard super class typedef support. */
-  typedef ImageToImageFilter< InputImageType, OutputImageType > Superclass;
+  /** Standard super class type alias support */
+  using Superclass = ImageToImageFilter<InputImageType, OutputImageType>;
 
   /** Typedef support for the input image scalar value type. */
-  typedef typename InputImageType::PixelType ScalarType;
+  using ScalarType = typename InputImageType::PixelType;
 
-  /** Smart pointer typedef support  */
-  typedef SmartPointer< Self > Pointer;
+  /** Smart pointer type alias support  */
+  using Pointer = SmartPointer<Self>;
 
   /** Run-time type information (and related methods) */
   itkTypeMacro(WatershedImageFilter, ImageToImageFilter);
@@ -186,47 +185,56 @@ public:
   itkNewMacro(Self);
 
   /** Standard process object method.  This filter is not multithreaded. */
-  void GenerateData() ITK_OVERRIDE;
+  void
+  GenerateData() override;
 
   /** Overloaded to link the input to this filter with the input of the
       mini-pipeline */
   using Superclass::SetInput;
-  void SetInput(const InputImageType *input) ITK_OVERRIDE
+  void
+  SetInput(const InputImageType * input) override
   {
     // if the input is changed, we'll need to clear the cached tree
     // when we execute
-    if ( input != this->GetInput(0) )
-      {
+    if (input != this->GetInput(0))
+    {
       m_InputChanged = true;
-      }
+    }
 
     // processObject is not const-correct so a const_cast is needed here
-    this->ProcessObject::SetNthInput( 0, const_cast< InputImageType * >( input ) );
-    m_Segmenter->SetInputImage( const_cast< InputImageType * >( input ) );
+    this->ProcessObject::SetNthInput(0, const_cast<InputImageType *>(input));
+    m_Segmenter->SetInputImage(const_cast<InputImageType *>(input));
   }
 
-  void SetInput(unsigned int i, const TInputImage *image) ITK_OVERRIDE
+  void
+  SetInput(unsigned int i, const TInputImage * image) override
   {
-    if ( i != 0 )
-                  { itkExceptionMacro(<< "Filter has only one input."); }
+    if (i != 0)
+    {
+      itkExceptionMacro(<< "Filter has only one input.");
+    }
     else
-                  { this->SetInput(image); }
+    {
+      this->SetInput(image);
+    }
   }
 
   /** Set/Get the input thresholding parameter.  Units are a percentage of
    * the maximum depth in the image. */
-  void SetThreshold(double);
+  void
+  SetThreshold(double);
 
   itkGetConstMacro(Threshold, double);
 
   /** Set/Get the flood level for generating the merge tree from the initial
    * segmentation   */
-  void SetLevel(double);
+  void
+  SetLevel(double);
 
   itkGetConstMacro(Level, double);
 
   /** Get the basic segmentation from the Segmenter member filter. */
-  typename watershed::Segmenter< InputImageType >::OutputImageType *
+  typename watershed::Segmenter<InputImageType>::OutputImageType *
   GetBasicSegmentation()
   {
     m_Segmenter->Update();
@@ -234,60 +242,57 @@ public:
   }
 
   /** Get the segmentation tree from from the TreeGenerator member filter. */
-  typename watershed::SegmentTreeGenerator< ScalarType >::SegmentTreeType *
+  typename watershed::SegmentTreeGenerator<ScalarType>::SegmentTreeType *
   GetSegmentTree()
   {
     return m_TreeGenerator->GetOutputSegmentTree();
   }
 
   // Override since the filter produces all of its output
-  void EnlargeOutputRequestedRegion(DataObject *data) ITK_OVERRIDE;
+  void
+  EnlargeOutputRequestedRegion(DataObject * data) override;
 
 #ifdef ITK_USE_CONCEPT_CHECKING
   // Begin concept checking
-  itkConceptMacro( InputEqualityComparableCheck,
-                   ( Concept::EqualityComparable< ScalarType > ) );
-  itkConceptMacro( InputAdditiveOperatorsCheck,
-                   ( Concept::AdditiveOperators< ScalarType > ) );
-  itkConceptMacro( DoubleInputMultiplyOperatorCheck,
-                   ( Concept::MultiplyOperator< double, ScalarType, ScalarType > ) );
-  itkConceptMacro( InputLessThanComparableCheck,
-                   ( Concept::LessThanComparable< ScalarType > ) );
+  itkConceptMacro(InputEqualityComparableCheck, (Concept::EqualityComparable<ScalarType>));
+  itkConceptMacro(InputAdditiveOperatorsCheck, (Concept::AdditiveOperators<ScalarType>));
+  itkConceptMacro(DoubleInputMultiplyOperatorCheck, (Concept::MultiplyOperator<double, ScalarType, ScalarType>));
+  itkConceptMacro(InputLessThanComparableCheck, (Concept::LessThanComparable<ScalarType>));
   // End concept checking
 #endif
 
 protected:
   WatershedImageFilter();
-  ~WatershedImageFilter() ITK_OVERRIDE {}
-  void PrintSelf(std::ostream & os, Indent indent) const ITK_OVERRIDE;
+  ~WatershedImageFilter() override = default;
+  void
+  PrintSelf(std::ostream & os, Indent indent) const override;
 
   /** An opportunity to Allocate/Deallocate bulk data.
    */
-  void PrepareOutputs() ITK_OVERRIDE;
+  void
+  PrepareOutputs() override;
 
 private:
-  ITK_DISALLOW_COPY_AND_ASSIGN(WatershedImageFilter);
-
   /** A Percentage of the maximum depth (max - min pixel value) in the input
    *  image.  This percentage will be used to threshold the minimum values in
    *  the image. */
-  double m_Threshold;
+  double m_Threshold{ 0.0 };
 
   /** The percentage of the maximum saliency value among adjacencies in the
    *  segments of the initial segmentation to which "flooding" of the image
    *  should occur.  A tree of segment merges is calculated up to this
    *  level. */
-  double m_Level;
+  double m_Level{ 0.0 };
 
   /** The component parts of the segmentation algorithm.  These objects
    * must save state between calls to GenerateData() so that the
    * computationally expensive execution of segment tree generation is
    * not unnecessarily repeated. */
-  typename watershed::Segmenter< InputImageType >::Pointer m_Segmenter;
+  typename watershed::Segmenter<InputImageType>::Pointer m_Segmenter;
 
-  typename watershed::SegmentTreeGenerator< ScalarType >::Pointer m_TreeGenerator;
+  typename watershed::SegmentTreeGenerator<ScalarType>::Pointer m_TreeGenerator;
 
-  typename watershed::Relabeler< ScalarType, itkGetStaticConstMacro(ImageDimension) >::Pointer m_Relabeler;
+  typename watershed::Relabeler<ScalarType, Self::ImageDimension>::Pointer m_Relabeler;
 
   unsigned long m_ObserverTag;
 
@@ -300,7 +305,7 @@ private:
 } // end namespace itk
 
 #ifndef ITK_MANUAL_INSTANTIATION
-#include "itkWatershedImageFilter.hxx"
+#  include "itkWatershedImageFilter.hxx"
 #endif
 
 #endif
diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.hxx b/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.hxx
index 7132d40d83..bc7663b360 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedImageFilter.hxx
@@ -21,84 +21,76 @@
 
 namespace itk
 {
-template< typename TInputImage >
+template <typename TInputImage>
 void
-WatershedImageFilter< TInputImage >
-::SetThreshold(double val)
+WatershedImageFilter<TInputImage>::SetThreshold(double val)
 {
-  if ( val < 0.0 )
-    {
+  if (val < 0.0)
+  {
     val = 0.0;
-    }
-  else if ( val > 1.0 )
-    {
+  }
+  else if (val > 1.0)
+  {
     val = 1.0;
-    }
+  }
 
-CLANG_PRAGMA_PUSH
-CLANG_SUPPRESS_Wfloat_equal
-  if ( val != m_Threshold )
-CLANG_PRAGMA_POP
-    {
+  CLANG_PRAGMA_PUSH
+  CLANG_SUPPRESS_Wfloat_equal if (val != m_Threshold) CLANG_PRAGMA_POP
+  {
     m_Threshold = val;
     m_Segmenter->SetThreshold(m_Threshold);
 
     m_ThresholdChanged = true;
     this->Modified();
-    }
+  }
 }
 
-template< typename TInputImage >
+template <typename TInputImage>
 void
-WatershedImageFilter< TInputImage >
-::SetLevel(double val)
+WatershedImageFilter<TInputImage>::SetLevel(double val)
 {
-  if ( val < 0.0 )
-    {
+  if (val < 0.0)
+  {
     val = 0.0;
-    }
-  else if ( val > 1.0 )
-    {
+  }
+  else if (val > 1.0)
+  {
     val = 1.0;
-    }
+  }
 
-CLANG_PRAGMA_PUSH    \
-CLANG_SUPPRESS_Wfloat_equal   \
-  if ( val != m_Level )
-CLANG_PRAGMA_POP    \
-    {
+  CLANG_PRAGMA_PUSH
+  CLANG_SUPPRESS_Wfloat_equal if (val != m_Level) CLANG_PRAGMA_POP
+  {
     m_Level = val;
     m_TreeGenerator->SetFloodLevel(m_Level);
     m_Relabeler->SetFloodLevel(m_Level);
 
     m_LevelChanged = true;
     this->Modified();
-    }
+  }
 }
 
-template< typename TInputImage >
-WatershedImageFilter< TInputImage >
-::WatershedImageFilter():m_Threshold(0.0), m_Level(0.0)
+template <typename TInputImage>
+WatershedImageFilter<TInputImage>::WatershedImageFilter()
 {
   // Set up the mini-pipeline for the first execution.
-  m_Segmenter    = watershed::Segmenter< InputImageType >::New();
-  m_TreeGenerator = watershed::SegmentTreeGenerator< ScalarType >::New();
-  m_Relabeler    = watershed::Relabeler< ScalarType, ImageDimension >::New();
+  m_Segmenter = watershed::Segmenter<InputImageType>::New();
+  m_TreeGenerator = watershed::SegmentTreeGenerator<ScalarType>::New();
+  m_Relabeler = watershed::Relabeler<ScalarType, ImageDimension>::New();
 
   m_Segmenter->SetDoBoundaryAnalysis(false);
   m_Segmenter->SetSortEdgeLists(true);
-  m_Segmenter->SetThreshold( this->GetThreshold() );
+  m_Segmenter->SetThreshold(this->GetThreshold());
 
-  m_TreeGenerator->SetInputSegmentTable( m_Segmenter->GetSegmentTable() );
+  m_TreeGenerator->SetInputSegmentTable(m_Segmenter->GetSegmentTable());
   m_TreeGenerator->SetMerge(false);
-  m_TreeGenerator->SetFloodLevel( this->GetLevel() );
+  m_TreeGenerator->SetFloodLevel(this->GetLevel());
 
-  m_Relabeler->SetInputSegmentTree( m_TreeGenerator->GetOutputSegmentTree() );
-  m_Relabeler->SetInputImage( m_Segmenter->GetOutputImage() );
-  m_Relabeler->SetFloodLevel( this->GetLevel() );
+  m_Relabeler->SetInputSegmentTree(m_TreeGenerator->GetOutputSegmentTree());
+  m_Relabeler->SetInputImage(m_Segmenter->GetOutputImage());
+  m_Relabeler->SetFloodLevel(this->GetLevel());
 
-  WatershedMiniPipelineProgressCommand::Pointer c =
-    WatershedMiniPipelineProgressCommand::New();
+  WatershedMiniPipelineProgressCommand::Pointer c = WatershedMiniPipelineProgressCommand::New();
   c->SetFilter(this);
   c->SetNumberOfFilters(3);
 
@@ -111,19 +103,17 @@ WatershedImageFilter< TInputImage >
   m_ThresholdChanged = true;
 }
 
-template< typename TInputImage >
+template <typename TInputImage>
 void
-WatershedImageFilter< TInputImage >
-::EnlargeOutputRequestedRegion(DataObject *data)
+WatershedImageFilter<TInputImage>::EnlargeOutputRequestedRegion(DataObject * data)
 {
   Superclass::EnlargeOutputRequestedRegion(data);
   data->SetRequestedRegionToLargestPossibleRegion();
 }
 
-template< typename TInputImage >
+template <typename TInputImage>
 void
-WatershedImageFilter< TInputImage >
-::PrepareOutputs()
+WatershedImageFilter<TInputImage>::PrepareOutputs()
 {
   // call the superclass' method to clear out the outputs
   Superclass::PrepareOutputs();
@@ -140,16 +130,14 @@ WatershedImageFilter< TInputImage >
   // Relabeler need to re-execute.  Plus, the
   // HighestCalculatedFloodLevel must be reset on the Tree Generator
   //
-  if ( m_InputChanged
-       || ( this->GetInput()->GetPipelineMTime() > m_GenerateDataMTime )
-       || m_ThresholdChanged )
-    {
+  if (m_InputChanged || (this->GetInput()->GetPipelineMTime() > m_GenerateDataMTime) || m_ThresholdChanged)
+  {
     m_Segmenter->PrepareOutputs();
     m_TreeGenerator->PrepareOutputs();
     m_Relabeler->PrepareOutputs();
 
     m_TreeGenerator->SetHighestCalculatedFloodLevel(0.0);
-    }
+  }
 
   // If the flood level changed but is below the Tree
   // Generator::HighestCalculatedFloodLevel, then only the Relabeler
@@ -159,46 +147,42 @@ WatershedImageFilter< TInputImage >
   // Generator::HighestCalculatedFloodLevel, then the Tree Generator +
   // Relabeler must execute.
   //
-  if ( m_LevelChanged )
+  if (m_LevelChanged)
+  {
+    if (m_Level <= m_TreeGenerator->GetHighestCalculatedFloodLevel())
     {
-    if ( m_Level <= m_TreeGenerator->GetHighestCalculatedFloodLevel() )
-      {
       m_Relabeler->PrepareOutputs();
-      }
+    }
     else
-      {
+    {
       m_TreeGenerator->PrepareOutputs();
       m_Relabeler->PrepareOutputs();
-      }
     }
+  }
 }
 
-template< typename TInputImage >
+template <typename TInputImage>
 void
-WatershedImageFilter< TInputImage >
-::GenerateData()
+WatershedImageFilter<TInputImage>::GenerateData()
 {
   // Set the largest possible region in the segmenter
-  m_Segmenter->SetLargestPossibleRegion( this->GetInput()
-                                         ->GetLargestPossibleRegion() );
-  m_Segmenter->GetOutputImage()
-  ->SetRequestedRegion( this->GetInput()->GetLargestPossibleRegion() );
+  m_Segmenter->SetLargestPossibleRegion(this->GetInput()->GetLargestPossibleRegion());
+  m_Segmenter->GetOutputImage()->SetRequestedRegion(this->GetInput()->GetLargestPossibleRegion());
 
   // Setup the progress command
   WatershedMiniPipelineProgressCommand::Pointer c =
-    dynamic_cast< WatershedMiniPipelineProgressCommand * >(
-      m_TreeGenerator->GetCommand(m_ObserverTag) );
+    dynamic_cast<WatershedMiniPipelineProgressCommand *>(m_TreeGenerator->GetCommand(m_ObserverTag));
   c->SetCount(0.0);
   c->SetNumberOfFilters(3);
 
   // Graft our output on the relabeler
-  m_Relabeler->GraftOutput( this->GetOutput() );
+  m_Relabeler->GraftOutput(this->GetOutput());
 
   // Update the mini-pipeline
   m_Relabeler->Update();
 
   // Graft the output of the relabeler back on this filter
-  this->GraftOutput( m_Relabeler->GetOutputImage() );
+  this->GraftOutput(m_Relabeler->GetOutputImage());
 
   // Keep track of when we last executed
   m_GenerateDataMTime.Modified();
@@ -209,10 +193,9 @@ WatershedImageFilter< TInputImage >
   m_ThresholdChanged = false;
 }
 
-template< typename TInputImage >
+template <typename TInputImage>
 void
-WatershedImageFilter< TInputImage >
-::PrintSelf(std::ostream & os, Indent indent) const
+WatershedImageFilter<TInputImage>::PrintSelf(std::ostream & os, Indent indent) const
 {
   Superclass::PrintSelf(os, indent);
   os << indent << "Threshold: " << m_Threshold << std::endl;
diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedMiniPipelineProgressCommand.h b/Modules/Segmentation/Watersheds/include/itkWatershedMiniPipelineProgressCommand.h
index 2f7c11badd..6032b00a25 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedMiniPipelineProgressCommand.h
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedMiniPipelineProgressCommand.h
@@ -31,28 +31,36 @@ namespace itk
  * implementing the mini-pipeline).
  * \ingroup ITKWatersheds
  */
-class ITKWatersheds_EXPORT WatershedMiniPipelineProgressCommand:public Command
+class ITKWatersheds_EXPORT WatershedMiniPipelineProgressCommand : public Command
 {
 public:
   /** Smart pointer declaration methods */
-  typedef WatershedMiniPipelineProgressCommand Self;
-  typedef Command                              Superclass;
-  typedef itk::SmartPointer< Self >            Pointer;
-  typedef itk::SmartPointer< const Self >      ConstPointer;
+  using Self = WatershedMiniPipelineProgressCommand;
+  using Superclass = Command;
+  using Pointer = itk::SmartPointer<Self>;
+  using ConstPointer = itk::SmartPointer<const Self>;
   itkTypeMacro(WatershedMiniPipelineProgressCommand, Command);
   itkNewMacro(Self);
 
   /** Standard Command virtual methods */
-  void Execute(Object *caller, const EventObject & event) ITK_OVERRIDE;
+  void
+  Execute(Object * caller, const EventObject & event) override;
 
-  void Execute(const Object *caller, const EventObject & event) ITK_OVERRIDE;
+  void
+  Execute(const Object * caller, const EventObject & event) override;
 
   /** Set/Get the filter whose UpdateProgress will be set by this
    * command object */
-  void SetFilter(ProcessObject *p)
-  { m_Filter = p; }
-  const ProcessObject * GetFilter()
-  { return m_Filter; }
+  void
+  SetFilter(ProcessObject * p)
+  {
+    m_Filter = p;
+  }
+  const ProcessObject *
+  GetFilter()
+  {
+    return m_Filter;
+  }
 
   /** Set/Get the base count for stepping through filter progress values */
   itkSetMacro(Count, double);
@@ -64,15 +72,15 @@ public:
   itkGetConstMacro(NumberOfFilters, unsigned int);
 
 protected:
-  WatershedMiniPipelineProgressCommand():m_Count(0.0), m_Filter(ITK_NULLPTR),
-    m_NumberOfFilters(1) {}
-  ~WatershedMiniPipelineProgressCommand() ITK_OVERRIDE {}
-  void PrintSelf(std::ostream & os, Indent indent) const ITK_OVERRIDE;
+  WatershedMiniPipelineProgressCommand() {}
+  ~WatershedMiniPipelineProgressCommand() override = default;
+  void
+  PrintSelf(std::ostream & os, Indent indent) const override;
 
 private:
-  double         m_Count;
-  ProcessObject *m_Filter;
-  unsigned int   m_NumberOfFilters;
+  double          m_Count{ 0.0 };
+  ProcessObject * m_Filter{ nullptr };
+  unsigned int    m_NumberOfFilters{ 1 };
 };
 } // end namespace itk
 
diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedRelabeler.h b/Modules/Segmentation/Watersheds/include/itkWatershedRelabeler.h
index 2293aa00a7..6d55e03cc2 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedRelabeler.h
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedRelabeler.h
@@ -60,74 +60,78 @@ namespace watershed
  * \sa itk::watershed::SegmentTree
  * \ingroup ITKWatersheds
  */
-template< typename TScalar, unsigned int TImageDimension >
-class ITK_TEMPLATE_EXPORT Relabeler:
-  public ProcessObject
+template <typename TScalar, unsigned int TImageDimension>
+class ITK_TEMPLATE_EXPORT Relabeler : public ProcessObject
 {
 public:
   /** Define smart pointers for this object */
-  typedef Relabeler                  Self;
-  typedef ProcessObject              Superclass;
-  typedef SmartPointer< Self >       Pointer;
-  typedef SmartPointer< const Self > ConstPointer;
+  using Self = Relabeler;
+  using Superclass = ProcessObject;
+  using Pointer = SmartPointer<Self>;
+  using ConstPointer = SmartPointer<const Self>;
 
   /** Method for creation through the object factory. */
   itkNewMacro(Self);
   itkTypeMacro(WatershedRelabeler, ProcessObject);
 
   /** Expose the ImageDimension template parameter at run time */
-  itkStaticConstMacro(ImageDimension, unsigned int, TImageDimension);
+  static constexpr unsigned int ImageDimension = TImageDimension;
 
-  /** Some convenient typedefs */
-  typedef TScalar                                           ScalarType;
-  typedef Image< IdentifierType, TImageDimension >          ImageType;
-  typedef SegmentTree< ScalarType >                         SegmentTreeType;
-  typedef Segmenter< Image< ScalarType, TImageDimension > > SegmenterType;
-  typedef DataObject::Pointer                               DataObjectPointer;
+  /** Some convenient type alias */
+  using ScalarType = TScalar;
+  using ImageType = Image<IdentifierType, TImageDimension>;
+  using SegmentTreeType = SegmentTree<ScalarType>;
+  using SegmenterType = Segmenter<Image<ScalarType, TImageDimension>>;
+  using DataObjectPointer = DataObject::Pointer;
 
   /** Standard itk::ProcessObject subclass method. */
-  typedef ProcessObject::DataObjectPointerArraySizeType DataObjectPointerArraySizeType;
+  using DataObjectPointerArraySizeType = ProcessObject::DataObjectPointerArraySizeType;
   using Superclass::MakeOutput;
-  DataObjectPointer MakeOutput(DataObjectPointerArraySizeType idx) ITK_OVERRIDE;
+  DataObjectPointer
+  MakeOutput(DataObjectPointerArraySizeType idx) override;
 
   /** Set/Get the input image */
-  void SetInputImage(ImageType *img)
+  void
+  SetInputImage(ImageType * img)
   {
     this->ProcessObject::SetNthInput(0, img);
   }
 
-  ImageType * GetInputImage(void)
+  ImageType *
+  GetInputImage()
   {
-    return itkDynamicCastInDebugMode< ImageType * >
-           ( this->ProcessObject::GetInput(0) );
+    return itkDynamicCastInDebugMode<ImageType *>(this->ProcessObject::GetInput(0));
   }
 
   /** Set/Get the output image */
-  void SetOutputImage(ImageType *img)
+  void
+  SetOutputImage(ImageType * img)
   {
     this->ProcessObject::SetNthOutput(0, img);
   }
 
-  ImageType * GetOutputImage(void)
+  ImageType *
+  GetOutputImage()
   {
-    return itkDynamicCastInDebugMode< ImageType * >
-           ( this->ProcessObject::GetOutput(0) );
+    return itkDynamicCastInDebugMode<ImageType *>(this->ProcessObject::GetOutput(0));
   }
 
   /** Set/Get the input tree that defines segment merges */
-  void SetInputSegmentTree(SegmentTreeType *et)
+  void
+  SetInputSegmentTree(SegmentTreeType * et)
   {
     this->ProcessObject::SetNthInput(1, et);
   }
 
-  SegmentTreeType * GetInputSegmentTree(void)
+  SegmentTreeType *
+  GetInputSegmentTree()
   {
-    return itkDynamicCastInDebugMode< SegmentTreeType * >
-           ( this->ProcessObject::GetInput(1) );
+    return itkDynamicCastInDebugMode<SegmentTreeType *>(this->ProcessObject::GetInput(1));
   }
 
   /** Standard non-threaded pipeline method */
-  void GenerateData() ITK_OVERRIDE;
+  void
+  GenerateData() override;
 
   /** Set/Get the percentage of the maximum saliency level
    * to merge to. */
@@ -135,27 +139,34 @@ public:
   itkGetConstMacro(FloodLevel, double);
 
   /** Standard ProcessObject method used in implementing mini-pipelines */
-  void GraftOutput(ImageType *graft);
+  void
+  GraftOutput(ImageType * graft);
 
-  void GraftNthOutput(unsigned int idx, ImageType *graft);
+  void
+  GraftNthOutput(unsigned int idx, ImageType * graft);
 
 protected:
   Relabeler();
-  ~Relabeler() ITK_OVERRIDE {}
+  ~Relabeler() override = default;
   Relabeler(const Self &) {}
-  void operator=(const Self &) {}
-  void PrintSelf(std::ostream & os, Indent indent) const ITK_OVERRIDE;
-
-  double m_FloodLevel;
-  void GenerateOutputRequestedRegion(DataObject *output) ITK_OVERRIDE;
-
-  void GenerateInputRequestedRegion() ITK_OVERRIDE;
+  void
+  operator=(const Self &)
+  {}
+  void
+  PrintSelf(std::ostream & os, Indent indent) const override;
+
+  double m_FloodLevel{ 0.0 };
+  void
+  GenerateOutputRequestedRegion(DataObject * output) override;
+
+  void
+  GenerateInputRequestedRegion() override;
 };
 } // end namespace watershed
 } // end namespace itk
 
 #ifndef ITK_MANUAL_INSTANTIATION
-#include "itkWatershedRelabeler.hxx"
+#  include "itkWatershedRelabeler.hxx"
 #endif
 
 #endif
